/* programma per il calcolo del prodotto matriciale tra A e B, dove
   A e B sono due matrici di dimensione r1xc1 e r2xc2 rispettivamente.
   Verificare se il prodotto matriciale è definito e in caso calcolare
   ma matrice risultate C = A*B   */

#include <stdio.h>
#define MAXEL 100

int main() {
    float A[MAXEL][MAXEL];
    float B[MAXEL][MAXEL];
    float C[MAXEL][MAXEL];
    int r1, c1;
    int r2, c2;    
    int i, j, k;  // contatori dei cicli
    float prodotto = 0;

    printf("Inserimento matrice A\n");
    printf("Comunicami numero di righe: ");
    scanf("%d",&r1);
    printf("Comunicami numero di colonne: ");
    scanf("%d",&c1);
    
    for (i=0;i<r1;i++) {
        for (j=0;j<c1;j++) {
            printf("Inserisci l'elemento A(%d,%d)",i+1,j+1);
            scanf("%f",&A[i][j]);
        }
    }

    printf("A=[\n");
    for (i=0;i<r1;i++) {
        for (j=0;j<c1;j++) {
            printf("%.2f ",A[i][j]);
        }
        printf("\n");
    }
    printf("]\n");    

    printf("Inserimento matrice B\n");
    printf("Comunicami numero di righe: ");
    scanf("%d",&r2);
    printf("Comunicami numero di colonne: ");
    scanf("%d",&c2);
    
    for (i=0;i<r2;i++) {
        for (j=0;j<c2;j++) {
            printf("Inserisci l'elemento B(%d,%d)",i+1,j+1);
            scanf("%f",&B[i][j]);
        }
    }
    
    printf("B=[\n");
    for (i=0;i<r2;i++) {
        for (j=0;j<c2;j++) {
            printf("%.2f ",B[i][j]);
        }
        printf("\n");
    }
    printf("]\n");

    if (c1==r2) {
        // supponiamo di voler calcolare l'elemento C(i,j)
        
        for (i=0;i<r1;i++) {
            for (j=0;j<c2;j++) {
                prodotto = 0;
                for (k=0;k<c1;k++) {
                    prodotto = prodotto + A[i][k]*B[k][j];
                }
                C[i][j] = prodotto;
                // C(i,j) corrisponde alla variabile prodotto
            }
        }

        printf("C=[\n");
        for (i=0;i<r1;i++) {
            for (j=0;j<c2;j++) {
                printf("%.2f ",C[i][j]);
            }
            printf("\n");
        }
        printf("]\n");
        
    } else {
        printf("Il prodotto A*B non e' definito\n");
    }
    
}
 
